fun aget(arr, idx)
  *(arr+idx)
end

fun aset(arr, idx, val)
  *(arr+idx) = val
end

fun swap(arr, i1, i2)
  let tmp = aget(arr, i1) in
    aset(arr, i1, aget(arr, i2));
    aset(arr, i2, tmp)
  end
end

fun partition(arr, l, r, ipivot)
  let vpivot = aget(arr, ipivot),
      pidx = l, i = l in
    swap(arr, ipivot, r);
    while i < r do
      if aget(arr, i) < vpivot+1 then
        swap(arr, i, pidx);
        pidx = pidx + 1
      else
        0
      end;
      i = i + 1
    end;
    swap(arr, pidx, r);
    pidx
  end
end

fun qsort(arr, l, r)
  if l < r then
    let pivot = partition(arr, l, r, l) in
      qsort(arr, l, pivot-1);
      qsort(arr, pivot+1, r)
    end
  else
    0
  end;
  arr
end

fun arr8(arr, a, b, c, d, e, f, g, h)
  aset(arr, 0, a);
  aset(arr, 1, b);
  aset(arr, 2, c);
  aset(arr, 3, d);
  aset(arr, 4, e);
  aset(arr, 5, f);
  aset(arr, 6, g);
  aset(arr, 7, h);
  arr
end

fun read_arr8(arr)
  aset(arr, 0, read);
  aset(arr, 1, read);
  aset(arr, 2, read);
  aset(arr, 3, read);
  aset(arr, 4, read);
  aset(arr, 5, read);
  aset(arr, 6, read);
  aset(arr, 7, read);
  arr
end

fun print_arr8(arr)
  print(aget(arr, 0), 
        aget(arr, 1),
        aget(arr, 2),
        aget(arr, 3),
        aget(arr, 4),
        aget(arr, 5),
        aget(arr, 6),
        aget(arr, 7))
end

let arr = arr8(1000, 3, 7, 8, 5, 2, 1, 9, 4) in
  print_arr8(qsort(arr, 0, 7));
  read_arr8(arr);
  print_arr8(qsort(arr, 0, 7))
end
